AlgorithmParameterGeneratorSpi (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.security, class: AlgorithmParameterGeneratorSpi
Keywords: java.security.AlgorithmParameterGeneratorSpi class

# Class AlgorithmParameterGeneratorSpi

java.lang.Object
java.security.AlgorithmParameterGeneratorSpi

public abstract class AlgorithmParameterGeneratorSpi extends Object
This class defines the Service Provider Interface (SPI) for the `AlgorithmParameterGenerator` class, which is used to generate a set of parameters to be used with a certain algorithm.

All the abstract methods in this class must be implemented by each cryptographic service provider who wishes to supply the implementation of a parameter generator for a particular algorithm.

In case the client does not explicitly initialize the AlgorithmParameterGenerator (via a call to an `engineInit` method), each provider must supply (and document) a default initialization. See the Keysize Restriction sections of the JDK Providers document for information on the AlgorithmParameterGenerator defaults used by JDK providers. However, note that defaults may vary across different providers. Additionally, the default value for a provider may change in a future version. Therefore, it is recommended to explicitly initialize the `AlgorithmParameterGenerator` instead of relying on provider-specific defaults.

Since:
  1.2
See Also:
  - `AlgorithmParameterGenerator`
  - `AlgorithmParameters`
  - `AlgorithmParameterSpec`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AlgorithmParameterGeneratorSpi()`
  Constructor for subclasses to call.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected abstract AlgorithmParameters`
  `engineGenerateParameters()`
  Generates the parameters.
  `protected abstract void`
  `engineInit(int size, SecureRandom random)`
  Initializes this parameter generator for a certain size and source of randomness.
  `protected abstract void`
  `engineInit(AlgorithmParameterSpec genParamSpec, SecureRandom random)`
  Initializes this parameter generator with a set of algorithm-specific parameter generation values.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### AlgorithmParameterGeneratorSpi

    public AlgorithmParameterGeneratorSpi()
    Constructor for subclasses to call.

- ## Method Details

  - ### engineInit

    protected abstract void engineInit(int size, SecureRandom random)
    Initializes this parameter generator for a certain size and source of randomness.
    Parameters:
      `size` - the size (number of bits).
      `random` - the source of randomness.

  - ### engineInit

    protected abstract void engineInit(AlgorithmParameterSpec genParamSpec, SecureRandom random) throws InvalidAlgorithmParameterException
    Initializes this parameter generator with a set of algorithm-specific parameter generation values.
    Parameters:
      `genParamSpec` - the set of algorithm-specific parameter generation values.
      `random` - the source of randomness.
    Throws:
      `InvalidAlgorithmParameterException` - if the given parameter generation values are inappropriate for this parameter generator.

  - ### engineGenerateParameters

    protected abstract AlgorithmParameters engineGenerateParameters()
    Generates the parameters.
    Returns:
      the new `AlgorithmParameters` object.